<?php

/**
 * Welcome Notice class.
 */
class Legacy_Book_Club_Welcome_Notice {

	/**
	** Constructor.
	*/
	public function __construct() {
		// Render Notice
		add_action( 'admin_notices', [$this, 'legacy_book_club_render_notice'] );

		// Enque AJAX Script
		add_action( 'admin_enqueue_scripts', [$this, 'legacy_book_club_admin_enqueue_scripts'], 5 );

		// Dismiss
		add_action( 'admin_enqueue_scripts', [$this, 'legacy_book_club_notice_enqueue_scripts'], 5 );
		add_action( 'wp_ajax_legacy_book_club_dismissed_handler', [$this, 'legacy_book_club_dismissed_handler'] );

		// Reset
		add_action( 'switch_theme', [$this, 'legacy_book_club_reset_notices'] );
		add_action( 'after_switch_theme', [$this, 'legacy_book_club_reset_notices'] );

	}

	/**
	** Render Notice
	*/
	public function legacy_book_club_render_notice() {
	global $pagenow;

	$legacy_book_club_screen = get_current_screen();

	if (
		$legacy_book_club_screen &&
		$legacy_book_club_screen->id !== 'appearance_page_legacy-book-club-theme-info' &&
		$legacy_book_club_screen->id !== 'appearance_page_legacy-book-club-demo'
	) {
		$legacy_book_club_transient_name = sprintf('%s_activation_notice', get_template());

		if ( ! get_transient($legacy_book_club_transient_name) ) {
			?>
			<div class="legacy-book-club-notice notice notice-info is-dismissible" data-notice="<?php echo esc_attr($legacy_book_club_transient_name); ?>">
				<button type="button" class="notice-dismiss"></button>

				<?php $this->legacy_book_club_render_notice_content(); ?>
			</div>
			<?php
		}
	}
}


	/**
	** Render Notice Content
	*/
	public function legacy_book_club_render_notice_content() {
		$legacy_book_club_action = 'install-activate';
		$legacy_book_club_redirect_url = 'admin.php?page=legacy-book-club-theme-info';
		$legacy_book_club_demo_redirect_url = 'themes.php?page=legacy-book-club-demo';
		$legacy_book_club_screen = get_current_screen();

		?>
		<div class="notice-left-icon-box">
			<span class="dashicons dashicons-businessperson notc-theme-icon"></span>
		</div>
		<div class="welcome-message">
			<div class="notc-contnt">
				<h4><?php esc_html_e('Thank you for installing Legacy Themes!', 'legacy-book-club'); ?></h4>
				<h1><?php esc_html_e('Welcome to Legacy Book Club WordPress Theme!', 'legacy-book-club'); ?></h1>
				<p><?php esc_html_e( 'Our WordPress themes are modern, minimalist, fully responsive, SEO-friendly, and packed with features—perfect for designers, bloggers, and creative professionals across various fields.', 'legacy-book-club' );?>
				</p>			
				<div class="action-buttons">
					<a href="<?php echo esc_url(admin_url($legacy_book_club_redirect_url)); ?>" class="button notice-btn button-hero" data-action="<?php echo esc_attr($legacy_book_club_action); ?>">
						<span class="notc-btn-txt"><?php echo esc_html__( 'Get Started with Legacy Book Club', 'legacy-book-club' ); ?></span>
					</a>
					<a href="<?php echo esc_url(admin_url($legacy_book_club_demo_redirect_url)); ?>" class="demo-btn btn" >
						<span class="demo-btn-txt"><?php echo esc_html__( 'Demo Import', 'legacy-book-club' ); ?></span>
					</a>
					<a href="<?php echo esc_url(LEGACY_BOOK_CLUB_THEME_BUNDLE_URL); ?>" target="_blank" class="bundle-btn btn" >
						<span class="demo-btn-txt"><?php echo esc_html__( 'Get All Themes', 'legacy-book-club' ); ?></span>
					</a>
				</div>
			</div>			
		</div>
		<div class="notice-right-img-box">
			<img class="notc-right-img" src="<?php echo esc_url( get_template_directory_uri() . '/inc/activation-notice/img/notice-right.png' ); ?>" alt="<?php esc_attr_e( 'notice themes img', 'legacy-book-club' ); ?>" />
		</div>

		<?php
	}

	/**
	** Reset Notice.
	*/
	public function legacy_book_club_reset_notices() {
		delete_transient( sprintf( '%s_activation_notice', get_template() ) );
	}

	/**
	** Dismissed handler
	*/
	public function legacy_book_club_dismissed_handler() {
		wp_verify_nonce( null );

		if ( isset( $_POST['notice'] ) ) {
			set_transient( sanitize_text_field( wp_unslash( $_POST['notice'] ) ), true, 0 );
		}
	}

	/**
	** Notice Enqunue Scripts
	*/
	public function legacy_book_club_notice_enqueue_scripts( $page ) {
		
		wp_enqueue_script( 'jquery' );

		ob_start();
		?>
		<script>
			jQuery(function($) {
				$( document ).on( 'click', '.legacy-book-club-notice .notice-dismiss', function () {
					jQuery.post( 'ajax_url', {
						action: 'legacy_book_club_dismissed_handler',
						notice: $( this ).closest( '.legacy-book-club-notice' ).data( 'notice' ),
					});
					$( '.legacy-book-club-notice' ).hide();
				} );
			});
		</script>
		<?php
		$script = str_replace( 'ajax_url', admin_url( 'admin-ajax.php' ), ob_get_clean() );

		wp_add_inline_script( 'jquery', str_replace( ['<script>', '</script>'], '', $script ) );
	}

	/**
	** Register scripts and styles for welcome notice.
	*/
	public function legacy_book_club_admin_enqueue_scripts( $page ) {
		// Enqueue Styles.
		wp_enqueue_style( 'legacy-book-club-welcome-notic-css', get_template_directory_uri() . '/inc/activation-notice/css/notice-bar.css' );
	}

}

new Legacy_Book_Club_Welcome_Notice();